Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/include/window.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/include/window.h	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/include/window.h	(revision 30)
@@ -14,4 +14,6 @@
 
 #include <iostream>
+#include <cmath>
+#include <sstream>
 #include <qstring.h>
 #include <qapplication.h>
@@ -36,4 +38,7 @@
 #include <qtreeview.h>
 #include <qdirmodel.h>
+#include <qevent.h>
+#include <qfiledialog.h>
+
 
 #include "Tools/Viewer/Parser/include/parser.h"
@@ -44,4 +49,7 @@
 #define EAST 2
 #define WEST 3
+
+#define MARGEX 50
+#define MARGEY 70
 
 using namespace morpheo::tools::viewer::parser;
@@ -62,35 +70,49 @@
 
   Window(QString name);
-  void _setParse(Parse *p);  
-  void _init_file();    
+  void _setParse(Parse *p);  //parse the base
+  void _init_file();    //search component and port before drawing
  private slots:
     
-  void _open();
-  void _open_end();
-  void _open_error();
+  void _open(); //open a file
+ void _open_error();
 
-  void _save();
+  void _save(); //save a file
   void _saveAs();
   void _saveAsOk();
-  void _close();
-  void _quit();
+
+  void _close(); //close a file
+
+  void _quit(); //quit a file
   void _quit2();
-  void _zoomIn();
+
+  void _zoomIn(); //zoom for the architecture view
   void _zoomOut();
   void _defautZoom();
-  void _level();
-  void _informations();
-  void _parameters();
-  void _about();
 
- private:
+  void _level();  
+  void _informations(); //show or hide informations window
+  void _parameters(); //show or hide parameters window
+  void _about(); //about the programm
+  void _component_name(); //show or hide the components name
+  void _signal_name(); //show or hide the signals name
 
-  void wparameters();
-  void winformations();
-  void paintEvent( QPaintEvent * );
-  void repaint();
-  void drawPort(int x,int y,int pos,string dir);
+  void _back();//return to the previous view
+  void _cancel_selection();
+  void _apply();
 
-  QList <Port> port_east;
+ protected :
+  void mousePressEvent (QMouseEvent *); //mouse handler when mouse pressed
+  void mouseMoveEvent (QMouseEvent *); //mouse handler in other case
+ private :
+  void wparameters(); // parameters window builder
+  void winformations(); //informations window builder
+  void paintEvent( QPaintEvent * ); //drawing panel
+  void repaint(); //repaint the panel with current parameters
+  void drawPort(int x,int y,int pos,string dir); //draw the components ports
+  void write_name(string name); //write the name of the component clicked name in the informations window
+  void write_comment(string comment);
+  void write_type(string t);
+
+  QList <Port> port_east; //ports lists
   QList <Port> port_west;
   QList <Port> port_north;
@@ -98,16 +120,20 @@
   QList <Component> *compo;
 
-  QWidget *wparam;
+  QWidget *wparam;//windows widget (informations, parameters, open, save ...)
   QWidget *winfo;
   QWidget *ws;
   QWidget *wq;
-  QWidget *wo;
   QWidget *wa;
 
-  Parse *parse;
-  BaseV *base;
-  BaseP p;
-  Entity *entity;
-  Coord *c;
+  QWidget *mess_charg;
+  QWidget *mess;
+  QBoxLayout *informations; //informations box
+  QBoxLayout *parameters; //parameters box
+
+  Parse *parse; //the parser
+  BaseV *base; //the current BaseV
+  BaseP p; //the current BaseP
+  Entity *entity; //entity of current base
+  Coord *c; 
  
   QPainter painter;
@@ -115,14 +141,23 @@
   QStatusBar *status;
 
-  QLineEdit *file_name;
-  QString current_name;
+  QLineEdit *file_name; //retrieve the name user wants to open from the open window
+  QString current_name; //name of the current file opened
 
-  int window_height;
+  /*items of the informations window*/
+  QLabel *lname;//name of the component clicked
+  QLabel *ln;
+  QLineEdit *comment;//comment associated with the component clicked
+  QLabel *lt;
+  QLabel *ltype;//type of the component
+  
+  int level; //level of architecture
+  int mouseX; //mouse position
+  int mouseY;
+
+  int window_height; //main window size
   int window_width;
-  int panel_heigth;
-  int panel_width;
-  int margeX;
+  int margeX;//size of the marge
   int margeY;
-  int portX;
+  int portX;//port size, position and size of components, used when drawing the architecture
   int portY;
   int posX;
@@ -131,17 +166,27 @@
   int tailleY;
 
-  bool save_as;
+  int cpt_level;
+  QString tab[50];
+
+  QString father;//father name
+  QString current;//name of the current architecture visible
+
+  bool save_as; 
   bool first_save;
-  bool info_open;
-  bool param_open;
-  bool is_save;
-  bool paint;
-  bool wq_open;
-  bool wo_open;
-  bool ws_open;
+  bool info_open; //know if the informations window opened or not
+  bool param_open; //know if the parameters window opened or not
+  bool is_save; //know if the file has been saved
+  bool paint; //(re)paint or not
+  bool wq_open; //know if Quit/Open ( 2 windows possible)/Save window is open
   bool wa_open;
-  bool quit_demand;
-  bool file_open;
-  bool is_parse;
+  bool quit_demand;//know if user clicked on "quit" (used for saving file before quit)
+  bool file_open;//know if a file is still open (used if user wants to open another file)
+  bool signalName;//show or hide signals name
+  bool componentName;//show or hide components name
+  bool charg_open;//back chargement message box opened or not
+  bool mess_open;//chargment message box opened or not
+  bool component_clicked;//if user clicked on a component to modify its parameters
+
+
 };
       };
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_about_actions.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_about_actions.cpp	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_about_actions.cpp	(revision 30)
@@ -0,0 +1,14 @@
+#include "window.h"
+
+using namespace std;
+using namespace morpheo::tools::viewer::parser;
+using namespace morpheo::tools::viewer::bdd;
+using namespace morpheo::tools::viewer::graphics;
+
+
+void Window::_about(){
+  QMessageBox *mess = new QMessageBox(this);
+  mess->setText("Viewer beta 1.0\n\nmade by : \nChou Philippe\nLafaye Michaël\nRosière Mathieu\n\nLip6 - 2007");
+  mess->addButton("ok",QMessageBox::YesRole);
+  mess->show();  
+}
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_drawAll.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_drawAll.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_drawAll.cpp	(revision 30)
@@ -7,18 +7,21 @@
 void Window::paintEvent( QPaintEvent * )
 {
-    
   /*draw window size*/
   setMinimumSize(600,600);
-    
+   
+  int schema;
+  QString t;
+ 
   if(paint){
-
     painter.begin(this);
     painter.setPen(Qt::blue);
-    painter.drawRect(margeX,margeY,margeX+450,margeY+450);
+    painter.drawRect(MARGEX,MARGEY,MARGEX+450,MARGEY+450);
+
     
     for(QList<Port>::iterator it=port_east.begin(); it!=port_east.end(); ++it){
       portX = it->get_x();
       portY = it->get_y();
-      drawPort(portX + margeX,portY + margeY ,EAST,it->getDirection());
+      drawPort(portX + MARGEX,portY + MARGEY ,EAST,it->getDirection());
+
     } 
     
@@ -26,5 +29,6 @@
       portX = it->get_x() ;
       portY = it->get_y() ;
-      drawPort(portX + margeX,portY + margeY, WEST, it->getDirection());
+      drawPort(portX + MARGEX,portY + MARGEY, WEST, it->getDirection());
+
     }
 
@@ -32,5 +36,6 @@
       portX = it->get_x() ;
       portY = it->get_y() ;
-      drawPort(portX + margeX ,portY+margeY,NORTH,it->getDirection());
+      drawPort(portX + MARGEX ,portY+MARGEY,NORTH,it->getDirection());
+
     }
 
@@ -38,18 +43,48 @@
       portX = it->get_x() ;
       portY = it->get_y() ;
-      drawPort(portX + margeX,portY+margeY,SOUTH,it->getDirection());
+      drawPort(portX + MARGEX,portY+MARGEY,SOUTH,it->getDirection());
+
     }
-
-
+    
     if(p.getArchitecture()!=NULL){
       compo = p.getComponent();
       for(QList<Component>::iterator it=compo->begin();it!=compo->end();++it){
 	Coord *co = it->get_Position();
-	posX = co->get_hg_x()+margeX;
-	posY = co->get_hg_y()+margeY;
+	posX = co->get_hg_x()+MARGEX;
+	posY = co->get_hg_y()+MARGEY;
 	tailleX = co->get_size_x();
 	tailleY = co->get_size_y();
-	painter.drawRect(posX,posY,tailleX,tailleY);
+	
+	t=QString::fromStdString(it->getType()).toLower();
+	BaseP tp = base->get_BasePos(t.toStdString());
+	if(&tp != NULL){
+	  schema=tp.getSchema();
+	  switch(schema){
+	  case 0:
+	    painter.drawRect(posX,posY,tailleX,tailleY);
+	    break;
+	  case 1:
+	    painter.drawEllipse(posX,posY,tailleX,tailleY);
+	    break;  
+	  case 2:
+	    painter.drawRect(posX,posY,tailleX,tailleY);
+	    painter.drawLine(posX+tailleX/4,posY+tailleY,posX+tailleX/4,posY);
+	    painter.drawLine(posX+tailleX/2,posY+tailleY,posX+tailleX/2,posY);
+	    painter.drawLine(posX+3*tailleX/4,posY+tailleY,posX+3*tailleX/4,posY);
+	    break;
+	  case 3:
+	    painter.drawRect(posX,posY,tailleX,tailleY);
+	    painter.drawLine(posX,posY+tailleY,posX+tailleX/2,posY+tailleY/2);
+	    painter.drawLine(posX+tailleX,posY+tailleY,posX+tailleX/2,posY+tailleY/2);
+	    break;
+	  }
+	}
+
+	if (componentName){
+	  QString compo_name = QString::fromStdString(it->getName());
+	  painter.drawText(posX , posY + tailleY/2,compo_name);
+	}
 	Coord *co2=new Coord( co->get_hg_x() + tailleX/2, co->get_hg_y() + tailleY/2,tailleX/2,tailleY/2);
+
 	QList<Port> ports2=(it->getPortEast(co2));
 	for (QList<Port>::iterator it2=ports2.begin();it2!=ports2.end();++it2) 
@@ -58,5 +93,5 @@
 	    portX =it2->get_x();
 	    portY =it2->get_y();
-	    drawPort(portX + margeX,portY+margeY , EAST,it2->getDirection());
+	    drawPort(portX + MARGEX,portY+MARGEY , EAST,it2->getDirection());
 	  }
 	ports2=(it->getPortWest(co));
@@ -66,5 +101,5 @@
 	    portX =it2->get_x();
 	    portY =it2->get_y();
-	    drawPort(portX + margeX ,portY+margeY ,WEST,it2->getDirection());
+	    drawPort(portX + MARGEX ,portY+MARGEY ,WEST,it2->getDirection());
 	  }
 	ports2=(it->getPortNorth(co));
@@ -74,5 +109,5 @@
 	    portX =it2->get_x();
 	    portY =it2->get_y();
-	    drawPort(portX + margeX ,portY+margeY,NORTH,it2->getDirection());
+	    drawPort(portX + MARGEX ,portY+MARGEY,NORTH,it2->getDirection());
 	    
 	  }
@@ -83,30 +118,37 @@
 	    portX =it2->get_x();
 	    portY =it2->get_y();
-	    drawPort(portX + margeX ,portY+margeY,SOUTH,it2->getDirection());
+	    drawPort(portX + MARGEX ,portY+MARGEY,SOUTH,it2->getDirection());
 
 	  }
 	painter.setPen(Qt::red);
         QList<PortMap> *pm=it->getPortMap();
-	//init_grid();
+	
 	for (QList<PortMap>::iterator it3=pm->begin();it3!=pm->end();++it3) 
 	  {
-	    Signal *s=base->getSignal(it->getType(),new PortMap(*it3));
-	    painter.drawLine(s->get_src_x()+margeX,s->get_src_y()+margeY,s->get_dest_x()+margeX,s->get_dest_y()+margeY);
-            //p1 = new Point(s->get_src_x()+2*margeX,s->get_src_y()+2*margeY,NULL,FREE,0); 
-	    //p2 = new Point(s->get_dest_x()+margeX,s->get_dest_y()+margeY,NULL,FREE,0);
-	   // grid[p1->getX()][p1->getY()] = p1;
-	    //grid[p2->getX()][p2->getY()] = p2;
-	    
-	    
-	    //drawSignal(p1,p2);
-            //p1 = NULL;p2 = NULL;
+	    Signal *s=base->getSignal(&p,it->getName(),new PortMap(*it3));
+	    painter.drawLine(s->get_src_x()+MARGEX,s->get_src_y()+MARGEY,s->get_dest_x()+MARGEX,s->get_dest_y()+MARGEY);
+
+	    if(signalName){
+	      QString signal_name = QString::fromStdString(it3->getName());
+	      if(s->get_src_x() > s->get_dest_x())
+		painter.drawText(s->get_dest_x() + MARGEX - 40 ,s->get_dest_y() + MARGEY-10, signal_name);
+	      if(s->get_src_x() < s->get_dest_x())
+		painter.drawText(s->get_dest_x() + MARGEX - 40 ,s->get_dest_y() + MARGEY-10, signal_name);
+	    }
+
 	  }
+	if(charg_open){
+	  charg_open = false;
+	  mess_charg->close();
+	}
         painter.setPen(Qt::blue);
       }
     }
     painter.end();
-    
-    
   }
+   if(mess_open){
+    mess_open = false;
+    mess->close();
+   }
 }
 
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_file_actions.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_file_actions.cpp	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_file_actions.cpp	(revision 30)
@@ -0,0 +1,190 @@
+#include "window.h"
+
+using namespace std;
+using namespace morpheo::tools::viewer::parser;
+using namespace morpheo::tools::viewer::bdd;
+using namespace morpheo::tools::viewer::graphics;
+
+
+/*signals actions implementation*/
+
+void Window::_open(){
+  QString current2;
+  if(!file_open && is_save){//if no file open or if the file opened has been saved -> open other file, else -> ask for saving file
+    current2 = QFileDialog::getOpenFileName(this,"", "./data");
+    if(current2!=""){
+      this->setDisabled(true);
+      current_name = current2;
+      if(parse->open_file( current_name.toStdString(),0)==-1)
+	_open_error();
+      else{
+	paint = false;
+	repaint();
+	_init_file();
+      }
+    }
+  }
+  else{
+    file_open = false;
+    if(!is_save){
+      wa_open = true;
+      wa = new QWidget();
+      QBoxLayout *other_box = new QBoxLayout(QBoxLayout::LeftToRight,0);
+      wa->setFixedSize(500,60);
+      wa->move(50,100);
+      QLabel *label = new QLabel("do you want to save this file?");
+      QPushButton *yes_save = new QPushButton("yes",wa);
+      QPushButton *no_save = new QPushButton("no",wa);
+      if(current_name!=NULL)
+	connect(yes_save,SIGNAL(clicked()),this,SLOT(_save()));
+      else 
+	connect(yes_save,SIGNAL(clicked()),this,SLOT(_saveAs()));
+      connect(no_save,SIGNAL(clicked()),this,SLOT(_open()));
+      other_box->addWidget(label);
+      other_box->addWidget(yes_save);
+      other_box->addWidget(no_save);
+      wa->setLayout(other_box);
+      wa->show();
+    }
+    else{
+      parse->closeBaseV();
+      _open();
+    }
+  }
+}
+
+void Window::_init_file(){
+  is_save = true;
+  base = parse->getBaseV();//parse the base and open the file
+  #ifdef DEBUG_ALL
+  base->afficheBaseConsole();
+  #endif
+  cpt_level = 0;
+  
+  tab[cpt_level] = "";
+  file_open = true;
+  QList <BaseP> *liste_compo = base->getBaseP();
+  p = liste_compo->at(0);
+  entity = p.getEntity();
+  current = QString::fromStdString(entity->getName());
+  c = new Coord(250,250,250,250);
+  port_east = entity->getPortEast(c);
+  port_west = entity->getPortWest(c);
+  port_north = entity->getPortNorth(c);
+  port_south = entity->getPortSouth(c);
+  paint = true;
+  repaint();
+  this->setDisabled(false);
+  setMouseTracking(true);
+}
+
+void Window::_open_error(){
+  QMessageBox *error = new QMessageBox(this);
+  error->setText("error : file doesn't exist or is not a valid format");
+  error->addButton("ok",QMessageBox::YesRole);
+  error->show();  
+}  
+
+
+void Window::_save(){
+  if(file_open){
+    if (wa_open)
+      wa->close();
+    if(save_as || first_save || (current_name==NULL)){//if "save as" or if it's the first time the user click on save (new file) -> save as
+      current_name = QFileDialog::getSaveFileName(this,"","./data");
+      save_as = false;
+      first_save = false;
+    }
+    else {
+      status->showMessage("file " + current_name + " saved",900);
+      is_save = true;//file saved
+    }
+    if(wa_open){
+      wa_open = false;
+      _open();
+    }
+  }
+  else{
+    QMessageBox *mess = new QMessageBox(this);
+    mess->setText("no file opened");
+    mess->addButton("ok",QMessageBox::YesRole);
+    mess->show(); 
+  }
+}
+
+void Window::_saveAs(){
+  if (wq_open){//if "quit" window is open, close it
+    wq->close();
+    wq_open = false;
+  }
+  save_as = true;
+  _save();
+}
+
+void Window::_saveAsOk(){
+  is_save = true;
+  status->showMessage("file " + current_name + " saved",900);
+  if(wa_open){
+    wa_open = false;
+    _open();
+  }
+  if(quit_demand)//if the user clicked on "quit" (but saved the file just before) -> quit the application
+    _quit2();
+}
+
+void Window::_close(){
+  paint = false;
+  parse->closeBaseV();
+  lname->setText("");
+  ln->setText("");
+  lt->setText("");
+  write_name("");
+  write_comment("");
+  comment->hide();
+  winfo->show();
+  file_open = false;
+  repaint();
+}
+
+void Window::_quit(){
+  //if the file is not saved -> ask to the user if he wants to save it. If yes -> save, else quit.
+  if(file_open && !is_save){
+    wq_open = true;
+    quit_demand = true;
+    wq = new QWidget();
+    QBoxLayout *quit_box = new QBoxLayout(QBoxLayout::LeftToRight,0);
+    wq->setWindowTitle("save : file name");
+    wq->setFixedSize(500,60);
+    wq->move(50,100);
+    QLabel *label = new QLabel("do you want to save this file?");
+    QPushButton *yes_save = new QPushButton("yes",wq);
+    QPushButton *no_save = new QPushButton("no",wq);
+    connect(yes_save,SIGNAL(clicked()),this,SLOT(_saveAs()));
+    connect(no_save,SIGNAL(clicked()),this,SLOT(_quit2()));
+    quit_box->addWidget(label);
+    quit_box->addWidget(yes_save);
+    quit_box->addWidget(no_save);
+    wq->setLayout(quit_box);
+    wq->show();
+  }
+  else
+    _quit2();
+}
+  
+void Window::_quit2(){
+  /*test if there are windows (other than the main window) opened*/
+
+  if(wq_open)
+    wq->close();
+  if(wa_open)
+    wa->close();
+  if(param_open)
+    wparam->close();
+  if(info_open)
+    winfo->close();
+  close();
+}
+
+
+
+
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_informations_window.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_informations_window.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_informations_window.cpp	(revision 30)
@@ -10,12 +10,62 @@
 {
   winfo = new QWidget();
-  QBoxLayout *informations = new QBoxLayout(QBoxLayout::LeftToRight,0);
-  winfo->resize(200,450);
+  informations = new QBoxLayout(QBoxLayout::TopToBottom,0);
   winfo->setWindowTitle("informations");
-  winfo->setFixedSize(200,620);
-  winfo->move(608,0);
+  winfo->setFixedSize(350,292);
+  winfo->move(628,50);
+
+  QBoxLayout *bname = new QBoxLayout(QBoxLayout::LeftToRight,0);
+  ln = new QLabel();
+  ln->setText("");
+  lname = new QLabel();
+  lname->setText("");
+  bname->addWidget(ln);
+  bname->addWidget(lname);
+
+  QBoxLayout *btype = new QBoxLayout(QBoxLayout::LeftToRight,0);
+  lt = new QLabel();
+  lt->setText("");
+  ltype = new QLabel();
+  ltype->setText("");
+  btype->addWidget(lt);
+  btype->addWidget(ltype);
+
+  comment = new QLineEdit();
+  comment->setText("");
+  comment->setReadOnly(true);
+
+  QPushButton *noselect = new QPushButton("cancel selection",wparam);
+  QPushButton *back = new QPushButton("back",wparam);
+  connect(back,SIGNAL(clicked()),this,SLOT(_back()));
+  connect(noselect,SIGNAL(clicked()),this,SLOT(_cancel_selection()));
+
+  informations->addLayout(bname);
+  informations->addLayout(btype);
+  informations->addWidget(comment);
+  informations->addWidget(noselect);
+  informations->addWidget(back);
+
   winfo->setLayout(informations);
   winfo->show();
 }
 
+void Window::write_comment(string cm){
+  QString c = QString::fromStdString(cm);
+  comment->setText(c);
+  comment->show();
+}
 
+void Window::write_name(string name){
+  QString n = QString::fromStdString(name);
+  lname->setText(n);
+}
+
+void Window::write_type(string type){
+  lt->setText("type");
+  QString n = QString::fromStdString(type);
+  ltype->setText(n);
+}
+
+void Window::_cancel_selection(){
+  component_clicked = false;
+}
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_main.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_main.cpp	(revision 30)
@@ -18,14 +18,15 @@
   if(argc>2){
     cout << "error : argument must be a file name or nothing" << endl;
+    cout << "usage : Viewer [file]" << endl;
     return 0;
   }
 
   Parse *par = new Parse();
-
+  
   
    QApplication *a=new QApplication (argc,argv);  
    
-   if(argc == 2){
-     if(par->open_file(argv[1])==-1){
+  if(argc == 2){
+     if(par->open_file(argv[1],0)==-1){
 	cout << "file doesn't exist or is not a valid format" << endl;  
 	exit(1);
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_main_window.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_main_window.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_main_window.cpp	(revision 30)
@@ -10,9 +10,10 @@
 {
   paint = false;
-  is_parse = false;
   window_height = 620;
-  window_width = 600;
-  margeX = 50;
-  margeY = 70;
+  window_width = 620;
+  charg_open = false;
+  mess_open = false; 
+  component_clicked = false;
+  cpt_level=0;
   
   /*menu bar*/
@@ -78,10 +79,21 @@
   connect(paramAct,SIGNAL(triggered()),this,SLOT(_parameters()));
 
+
+  QAction *compoNameAct;
+  compoNameAct = new QAction(tr("&components name"),this);
+  connect(compoNameAct,SIGNAL(triggered()),this,SLOT(_component_name()));
+
+  QAction *signalNameAct;
+  signalNameAct = new QAction(tr("&signals name"),this);
+  connect(signalNameAct,SIGNAL(triggered()),this,SLOT(_signal_name()));
+
   /*add the menu "tools" to the menu bar*/
   tools = menu_bar->addMenu(tr("&Tools"));
-  tools->addAction(zoomInAct);
-  tools->addAction(zoomOutAct);
-  tools->addAction(defautZoomAct);
-  tools->addAction(levelAct);
+  //tools->addAction(zoomInAct);
+  //tools->addAction(zoomOutAct);
+  //tools->addAction(defautZoomAct);
+  tools->addAction(compoNameAct);
+  tools->addAction(signalNameAct);
+  //tools->addAction(levelAct);
   tools->addAction(infoAct);
   tools->addAction(paramAct);
@@ -96,5 +108,4 @@
   help->addAction(aboutAct);
  
-
   /*add the menu bar to the main window*/
   this->setMenuWidget(menu_bar);
@@ -108,5 +119,5 @@
 
   /*defaut position*/
-  this->move(0,0);    
+  this->move(0,50);    
 
   /*main window title*/
@@ -125,8 +136,10 @@
 
   /*little windows (open, save...), closed at init*/
-  wo_open = false;
   wq_open = false;
-  ws_open = false;
   wa_open = false;
+
+  /*signals and components name hidden*/
+  signalName = false;
+  componentName = false;
 
   /*file unsaved at init*/
@@ -134,5 +147,4 @@
   first_save = false; //first_save = true for a new file
   
-
   current_name = name;
   if(current_name != NULL){
@@ -142,5 +154,5 @@
     file_open = false;
     paint = false;
-    is_save = false;
+    is_save = true;
   }
 }
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_mouseEvent.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_mouseEvent.cpp	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_mouseEvent.cpp	(revision 30)
@@ -0,0 +1,277 @@
+#include "window.h"
+
+using namespace std;
+using namespace morpheo::tools::viewer::parser;
+using namespace morpheo::tools::viewer::bdd;
+using namespace morpheo::tools::viewer::graphics;
+
+void Window::mousePressEvent (QMouseEvent *e){
+  if(paint && (p.getArchitecture() != NULL)){
+
+    compo = p.getComponent();
+    
+    QMouseEvent *mouseEvent = (QMouseEvent *) e;
+    
+    mouseX = mouseEvent->x();
+    mouseY = mouseEvent->y();
+    
+    bool bc = false;
+    int cx,cy,tx,ty;
+    string cc,nc,type;
+    bool found = false;
+
+    for(QList<Component>::iterator it=compo->begin();it!=compo->end();++it){
+      Coord *co = it->get_Position();
+      int px = co->get_hg_x();
+      int py = co->get_hg_y();
+      int taillex = co->get_size_x();
+      int tailley = co->get_size_y();
+      QString t=QString::fromStdString(it->getType()).toLower();
+      if(e->type() == QMouseEvent::MouseButtonDblClick && e->button() == Qt::LeftButton){
+	
+	if(mouseX >= px + MARGEX  && mouseY >= py +MARGEY && mouseX <= px+taillex + MARGEX  && mouseY <= py+tailley + MARGEY) {
+	  
+	  bc = false;
+	  paint = false;
+	  repaint();
+          found=true;
+	  this->setDisabled(true);
+	}
+      }
+      if(found){  
+       	mess = new QWidget();
+	mess->setFixedSize(200,50);
+	mess->move(200,50);
+	QBoxLayout *b = new QBoxLayout(QBoxLayout::TopToBottom,0);
+	QLabel *l = new QLabel();
+	l->setText("please wait while charging");
+	b->addWidget(l);
+	mess->setLayout(b);
+	mess->show();
+	mess_open = true;
+
+	p=base->get_BasePos(t.toStdString());
+	entity = p.getEntity();
+	c = new Coord(250,250,250,250);
+	port_east = entity->getPortEast(c);
+	port_west = entity->getPortWest(c);
+	port_north = entity->getPortNorth(c);
+	port_south = entity->getPortSouth(c);
+	if(cpt_level!=0)
+	  tab[cpt_level]=father;
+	father = current;
+	current = QString::fromStdString(t.toStdString());
+	cpt_level++;
+	tab[cpt_level] = father;
+	paint = true;
+	repaint();
+	write_name("");
+	write_comment("");
+	write_type("");
+	ln->setText("");
+	lt->setText("");
+	comment->hide();
+	found = false;
+	this->setDisabled(false);
+	component_clicked = false;
+      }
+      
+      if(e->type() == QMouseEvent::MouseButtonPress && e->button() == Qt::LeftButton){
+	if(mouseX >= px + MARGEX  && mouseY >= py +MARGEY && mouseX <= px+taillex + MARGEX  && mouseY <= py+tailley + MARGEY) {
+	  bc = true;
+	  nc = it->getName();
+	  cx = px;
+	  cy = py;
+	  tx = taillex;
+	  ty = tailley;
+	  type = it->getType();
+	  BaseP tp = base->get_BasePos(t.toStdString());
+	  if(&tp != NULL)
+		cc=tp.getComment();
+	  component_clicked = true;
+	}
+      }
+    }
+    if(bc){
+      write_name(nc);
+      write_type(type);
+      ln->setText("component");
+      lt->setText("type");
+      write_comment(cc);
+    }
+  }
+}
+
+
+void Window::mouseMoveEvent(QMouseEvent *e){
+  bool b  = false;
+  bool b2 = false;
+  bool b3 = false;
+  int px,py,taillex,tailley,ppx,ppy;
+  string s,s2,c,type;
+
+   if(paint && (p.getArchitecture() != NULL) && !component_clicked){
+
+    compo = p.getComponent();
+    
+    QMouseEvent *mouseEvent = (QMouseEvent *) e;
+
+    mouseX = mouseEvent->x();
+    mouseY = mouseEvent->y();
+    
+    for(QList<Component>::iterator it=compo->begin();it!=compo->end();++it){
+      Coord *co = it->get_Position();
+      px = co->get_hg_x();
+      py = co->get_hg_y();
+      taillex = co->get_size_x();
+      tailley = co->get_size_y();
+      QString t=QString::fromStdString(it->getType()).toLower();
+      QList<PortMap> *pm=it->getPortMap();
+
+      if(e->type() == QMouseEvent::MouseMove){
+	if(mouseX >= px + MARGEX  && mouseY >= py +MARGEY && mouseX <= px+taillex + MARGEX  && mouseY <= py+tailley + MARGEY) {
+	  b = true;
+	  s = it->getName();
+	  type = it->getType();
+	  BaseP tp=base->get_BasePos(t.toStdString());
+	  if(&tp!=NULL)
+	    c=tp.getComment();
+	  ppx = px;
+	  ppy = py;
+	  break;
+	}
+	else{
+	  for (QList<PortMap>::iterator it3=pm->begin();it3!=pm->end();++it3) {
+	  	Signal *sig=base->getSignal(&p,it->getName(),new PortMap(*it3));
+	  	if(mouseX >= sig->get_src_x() - 15  + MARGEX  && mouseY >= sig->get_src_y() - 15 + MARGEY && mouseX <= sig->get_src_x() + 15  + MARGEX  && mouseY <= sig->get_src_y() + 15 +MARGEY){
+		  b2 = true;
+	  	  s = it3->getName();
+		  break;
+	  	}
+	  }
+	}   
+      }
+    }
+    
+    if(b){
+      write_name(s);
+      write_type(type);
+      ln->setText("component");
+      write_comment(c);
+      lt->setText("type");
+      b3 = false;
+      b2 = false;
+    }
+    
+    if(b2){
+      write_name(s);
+      write_type("");
+      lt->setText("");
+      write_comment("");
+      ln->setText("signal");
+      comment->hide();
+      b3 = false;
+      b = false;
+    }
+
+    if(!b && !b2){
+      write_name("");
+      write_type("");
+      ln->setText("");
+      lt->setText("");
+      write_comment("");
+      comment->hide();
+    }
+   }
+  
+  
+   for(QList<Port>::iterator it=port_east.begin(); it!=port_east.end(); ++it){
+      portX = it->get_x();
+      portY = it->get_y();
+      if(mouseX >= portX - 15 + MARGEX && mouseY >= portY - 15 + MARGEY && mouseX <= portX + 15 +MARGEX && mouseY <= portY + 15 + MARGEY){
+	b3 = true;
+	s2 = it->getName();
+      }
+   } 
+   
+   for(QList<Port>::iterator it=port_west.begin(); it!=port_west.end(); ++it){
+     portX = it->get_x() ;
+     portY = it->get_y() ;
+     if(mouseX >= portX - 15 + MARGEX && mouseY >= portY - 15 + MARGEY && mouseX <= portX + 15 + MARGEX && mouseY <= portY + 15 + MARGEY){
+       b3 = true;
+       s2 = it->getName();
+     }
+   }
+   
+   for(QList<Port>::iterator it=port_north.begin(); it!=port_north.end(); ++it){
+     portX = it->get_x() ;
+     portY = it->get_y() ;
+     if(mouseX >= portX - 15 + MARGEX && mouseY >= portY - 15 +MARGEY && mouseX <= portX + 15 + MARGEX && mouseY <= portY + 15 +MARGEY){
+	b3 = true;
+	s2 = it->getName();
+     }
+   }
+   
+    for(QList<Port>::iterator it=port_south.begin(); it!=port_south.end(); ++it){
+      portX = it->get_x() ;
+      portY = it->get_y() ;
+      if(mouseX >= portX - 15 + MARGEX && mouseY >= portY - 15 + MARGEY && mouseX <= portX + 15 +MARGEX && mouseY <= portY + 15 + MARGEY){
+	b3 = true;
+	s2 = it->getName();
+      }
+    }
+    if(b3){
+      b = false;
+      write_name("");
+      write_name(s2);
+      write_type(type);
+      ln->setText("signal");
+      lt->setText("");
+      write_comment("");
+      comment->hide();
+    }
+}
+
+
+   
+ 
+void Window::_back(){
+  if(cpt_level==0){
+    QMessageBox *m = new QMessageBox(this);
+    m->setText("can't go up, you're on the top level !");
+    m->addButton("ok",QMessageBox::YesRole);
+    m->show();  
+  }
+  
+  else{
+    this->setDisabled(true);
+    paint = false;
+    repaint();
+    cpt_level--;
+    mess_charg = new QWidget();
+    mess_charg->setFixedSize(200,50);
+    mess_charg->move(200,50);
+    charg_open = true;
+    QBoxLayout *b = new QBoxLayout(QBoxLayout::TopToBottom,0);
+    QLabel *l = new QLabel();
+    l->setText("please wait while charging");
+    b->addWidget(l);
+    mess_charg->setLayout(b);
+    mess_charg->show();
+    
+    p = base->get_BasePos(father.toStdString());
+    entity = p.getEntity();
+    c = new Coord(250,250,250,250);
+    port_east = entity->getPortEast(c);
+    port_west = entity->getPortWest(c);
+    port_north = entity->getPortNorth(c);
+    port_south = entity->getPortSouth(c);
+    father = tab[cpt_level];
+    current = QString::fromStdString(entity->getName());
+    paint = true;
+    repaint();
+    this->setDisabled(false);
+    component_clicked = false;
+  }
+}
+
